'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _vue = require('vue');

var _vue2 = _interopRequireDefault(_vue);

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : { default: obj };
}

var props = {
  to: {
    type: String,
    required: true
  }
};

try {
  require.resolve('vue-router');
  // eslint-disable-next-line global-require
  var Router = require('vue-router');
  _vue2.default.use(Router);
  (0, _assign2.default)(props, (0, _extends3.default)({
    useVueRouter: {
      type: Boolean,
      default: true
    }
  }, _vue2.default.options.components['router-link'].options.props));
} catch (err) {
  _vue2.default.util.warn(err);
  _vue2.default.util.warn('Must import Vue Router before importing scouter-link to include Vue Router functionality.');
}

exports.default = {
  name: 'vue-scouter-link',
  props: props,
  computed: {
    computedProps: function computedProps() {
      return this.useVueRouter ? (0, _extends3.default)({
        is: 'router-link'
      }, this.$options.propsData) : (0, _extends3.default)({
        is: 'a',
        href: this.to
      }, this.$options.propsData);
    },

    atTargetRoute: function atTargetRoute() {
      if (!this.$el) {
        _vue2.default.util.warn('Cannot compare target route of Scouter Link before component has mounted.');
        return null;
      }
      return this.$el.origin === window.location.origin && this.$el.pathname === window.location.pathname;
    },
    targetEl: function targetEl() {
      if (!this.$el) {
        _vue2.default.util.warn('Cannot get target element of Scouter Link before component has mounted.');
        return null;
      }
      var res = this.atTargetRoute ? this.$el.hash.replace(/\?.*$/, '') : null;
      return res !== '' ? res : '#app';
    }
  },
  methods: {
    scrollToIfFound: function scrollToIfFound($event, options) {
      var _this = this;

      /* istanbul ignore else */
      if (this.$scrollTo) {
        var trackingAttempts = 10;
        var elementY = null;
        var previousY = null;
        var found = false;
        var trackElementY = function trackElementY() {
          trackingAttempts -= 1;
          var $targetEl = _this.targetEl && _this.targetEl.length > 0 ? document.querySelector(_this.targetEl) : 'body';
          if ($targetEl) {
            found = true;
            previousY = elementY;
            if (elementY !== $targetEl.offsetTop) {
              elementY = $targetEl.offsetTop;
              if (typeof _this.cancel === 'function') _this.cancel();
              _this.cancel = _this.$scrollTo($targetEl, undefined, options);
            }
          } else {
            window.scrollTop = 0;
          }
          setTimeout(function () {
            if (trackingAttempts > 0 && (!found || previousY !== elementY)) {
              trackElementY();
            }
          }, 1000 / 15);
        };
        trackElementY();
      }
    }
  }
};
if (module.exports.__esModule) module.exports = module.exports.default;(typeof module.exports === "function" ? module.exports.options : module.exports).template = "\n<component class=\"vue-scouter-link\" v-bind=\"computedProps\" @click=\"scrollToIfFound\" @click.native=\"scrollToIfFound\">\n  <slot></slot>\n</component>\n";
if (module.hot) {
  (function () {
    module.hot.accept();
    var hotAPI = require("vue-hot-reload-api");
    hotAPI.install(require("vue"), true);
    if (!hotAPI.compatible) return;
    if (!module.hot.data) {
      hotAPI.createRecord("_v-30183ea0", module.exports);
    } else {
      hotAPI.update("_v-30183ea0", module.exports, (typeof module.exports === "function" ? module.exports.options : module.exports).template);
    }
  })();
}